Package org.simpleframework.http

## Interface RequestHeader

- All Superinterfaces:
    `RequestLine`
  All Known Subinterfaces:
    `Request`
  All Known Implementing Classes:
    `RequestWrapper`

      public interface RequestHeader
      extends RequestLine

  This is a `Header` object that is used to represent a basic form for the HTTP request message. This is used to extract values such as the request line and header values from the request message. Access to header values is done case insensitively.

  As well as providing the header values and request line values this will also provide convenience methods which enable the user to determine the length of the body this message header prefixes.

  Author:
    Niall Gallagher

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `contains​(java.lang.String name)` | This is used to see if there is a HTTP message header with the given name in this container.
    `int` | `getContentLength()` | This is a convenience method that can be used to determine the length of the message body.
    `ContentType` | `getContentType()` | This is a convenience method that can be used to determine the content type of the message body.
    `Cookie` | `getCookie​(java.lang.String name)` | This is used to acquire a cookie using the name of that cookie.
    `java.util.List<Cookie>` | `getCookies()` | This is used to acquire all cookies that were sent in the header.
    `long` | `getDate​(java.lang.String name)` | This can be used to get the date of the first message header that has the specified name.
    `int` | `getInteger​(java.lang.String name)` | This can be used to get the integer of the first message header that has the specified name.
    `java.util.List<java.util.Locale>` | `getLocales()` | This is used to acquire the locales from the request header.
    `java.util.List<java.lang.String>` | `getNames()` | This method is used to get a `List` of the names for the headers.
    `java.lang.String` | `getValue​(java.lang.String name)` | This can be used to get the value of the first message header that has the specified name.
    `java.util.List<java.lang.String>` | `getValues​(java.lang.String name)` | This can be used to get the values of HTTP message headers that have the specified name.

    - ### Methods inherited from interface org.simpleframework.http.RequestLine

      `getAddress, getMajor, getMethod, getMinor, getPath, getQuery, getTarget`

- - ### Method Detail

    - #### getNames

          java.util.List<java.lang.String> getNames()

      This method is used to get a `List` of the names for the headers. This will provide the original names for the HTTP headers for the message. Modifications to the provided list will not affect the header, the list is a simple copy.
      Returns:
        this returns a list of the names within the header

    - #### getInteger

          int getInteger​(java.lang.String name)

      This can be used to get the integer of the first message header that has the specified name. This is a convenience method that avoids having to deal with parsing the value of the requested HTTP message header. This returns -1 if theres no HTTP header value for the specified name.
      Parameters:
        `name` - the HTTP message header to get the value from
      Returns:
        this returns the date as a long from the header value

    - #### getDate

          long getDate​(java.lang.String name)

      This can be used to get the date of the first message header that has the specified name. This is a convenience method that avoids having to deal with parsing the value of the requested HTTP message header. This returns -1 if theres no HTTP header value for the specified name.
      Parameters:
        `name` - the HTTP message header to get the value from
      Returns:
        this returns the date as a long from the header value

    - #### getCookie

          Cookie getCookie​(java.lang.String name)

      This is used to acquire a cookie using the name of that cookie. If the cookie exists within the HTTP header then it is returned as a `Cookie` object. Otherwise this method will return null. Each cookie object will contain the name, value and path of the cookie as well as the optional domain part.
      Parameters:
        `name` - this is the name of the cookie object to acquire
      Returns:
        this returns a cookie object from the header or null

    - #### getCookies

          java.util.List<Cookie> getCookies()

      This is used to acquire all cookies that were sent in the header. If any cookies exists within the HTTP header they are returned as `Cookie` objects. Otherwise this method will an empty list. Each cookie object will contain the name, value and path of the cookie as well as the optional domain part.
      Returns:
        this returns all cookie objects from the HTTP header

    - #### getValue

          java.lang.String getValue​(java.lang.String name)

      This can be used to get the value of the first message header that has the specified name. The value provided from this will be trimmed so there is no need to modify the value, also if the header name specified refers to a comma separated list of values the value returned is the first value in that list. This returns null if theres no HTTP message header.
      Parameters:
        `name` - the HTTP message header to get the value from
      Returns:
        this returns the value that the HTTP message header

    - #### getValues

          java.util.List<java.lang.String> getValues​(java.lang.String name)

      This can be used to get the values of HTTP message headers that have the specified name. This is a convenience method that will present that values as tokens extracted from the header. This has obvious performance benefits as it avoids having to deal with `substring` and `trim` calls.

      The tokens returned by this method are ordered according to there HTTP quality values, or "q" values, see RFC 2616 section 3.9. This also strips out the quality parameter from tokens returned. So "image/html; q=0.9" results in "image/html". If there are no "q" values present then order is by appearance.

      The result from this is either the trimmed header value, that is, the header value with no leading or trailing whitespace or an array of trimmed tokens ordered with the most preferred in the lower indexes, so index 0 is has highest preference.

      Parameters:
        `name` - the name of the headers that are to be retrieved
      Returns:
        ordered array of tokens extracted from the header(s)

    - #### getLocales

          java.util.List<java.util.Locale> getLocales()

      This is used to acquire the locales from the request header. The locales are provided in the `Accept-Language` header. This provides an indication as to the languages that the client accepts. It provides the locales in preference order.
      Returns:
        this returns the locales preferred by the client

    - #### contains

          boolean contains​(java.lang.String name)

      This is used to see if there is a HTTP message header with the given name in this container. If there is a HTTP message header with the specified name then this returns true otherwise false.
      Parameters:
        `name` - the HTTP message header to get the value from
      Returns:
        this returns true if the HTTP message header exists

    - #### getContentType

          ContentType getContentType()

      This is a convenience method that can be used to determine the content type of the message body. This will determine whether there is a `Content-Type` header, if there is then this will parse that header and represent it as a typed object which will expose the various parts of the HTTP header.
      Returns:
        this returns the content type value if it exists

    - #### getContentLength

          int getContentLength()

      This is a convenience method that can be used to determine the length of the message body. This will determine if there is a `Content-Length` header, if it does then the length can be determined, if not then this returns -1.
      Returns:
        the content length, or -1 if it cannot be determined